package com.ints.bieshop.domain;

import static org.assertj.core.api.Assertions.assertThat;

public class InventoryTransactionsAsserts {

    /**
     * Asserts that the entity has all properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertInventoryTransactionsAllPropertiesEquals(InventoryTransactions expected, InventoryTransactions actual) {
        assertInventoryTransactionsAutoGeneratedPropertiesEquals(expected, actual);
        assertInventoryTransactionsAllUpdatablePropertiesEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all updatable properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertInventoryTransactionsAllUpdatablePropertiesEquals(
        InventoryTransactions expected,
        InventoryTransactions actual
    ) {
        assertInventoryTransactionsUpdatableFieldsEquals(expected, actual);
        assertInventoryTransactionsUpdatableRelationshipsEquals(expected, actual);
    }

    /**
     * Asserts that the entity has all the auto generated properties (fields/relationships) set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertInventoryTransactionsAutoGeneratedPropertiesEquals(
        InventoryTransactions expected,
        InventoryTransactions actual
    ) {
        assertThat(expected)
            .as("Verify InventoryTransactions auto generated properties")
            .satisfies(e -> assertThat(e.getId()).as("check id").isEqualTo(actual.getId()));
    }

    /**
     * Asserts that the entity has all the updatable fields set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertInventoryTransactionsUpdatableFieldsEquals(InventoryTransactions expected, InventoryTransactions actual) {
        assertThat(expected)
            .as("Verify InventoryTransactions relevant properties")
            .satisfies(e -> assertThat(e.getQuantity()).as("check quantity").isEqualTo(actual.getQuantity()))
            .satisfies(e -> assertThat(e.getUnitPrice()).as("check unitPrice").isEqualTo(actual.getUnitPrice()))
            .satisfies(e -> assertThat(e.getTransactionDate()).as("check transactionDate").isEqualTo(actual.getTransactionDate()))
            .satisfies(e -> assertThat(e.getNote()).as("check note").isEqualTo(actual.getNote()))
            .satisfies(e -> assertThat(e.getIsDeleted()).as("check isDeleted").isEqualTo(actual.getIsDeleted()));
    }

    /**
     * Asserts that the entity has all the updatable relationships set.
     *
     * @param expected the expected entity
     * @param actual the actual entity
     */
    public static void assertInventoryTransactionsUpdatableRelationshipsEquals(
        InventoryTransactions expected,
        InventoryTransactions actual
    ) {
        assertThat(expected)
            .as("Verify InventoryTransactions relationships")
            .satisfies(e -> assertThat(e.getSupplier()).as("check supplier").isEqualTo(actual.getSupplier()))
            .satisfies(e -> assertThat(e.getProduct()).as("check product").isEqualTo(actual.getProduct()));
    }
}
